﻿Type=Service
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public manager As BleManager2
	Public currentStateText As String = "UNKNOWN"
	
End Sub

Sub Service_Create
	manager.Initialize("manager")
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub



Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	CallSub(Main, "BleStateChanged")
	If State = manager.STATE_POWERED_ON Then
		manager.Scan2(Array (UUID("FFE0")), True)
	End If
End Sub


Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Dim key As Int = 22
	If AdvertisingData.ContainsKey(key) Then
		Dim b() As Byte = AdvertisingData.Get(key)
		If b.Length > 2 Then
			Dim s As String
			If b(2) = 0 Then s = "Button Up" Else s = "Button Down"
			CallSub2(Main, "Button_State_Changed", $"Button State: ${s} ($Time{DateTime.Now})"$)
		End If
	End If

End Sub

Private Sub UUID(id As String) As String
#if B4A
	Return "0000" & id.ToLowerCase & "-0000-1000-8000-00805f9b34fb"
#else if B4I
	Return id.ToUpperCase
#End If
End Sub



'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
